Subject: bug#66050: Making perl-mode.el obsolete

From: Harald Jörg <[email-masked]>
Date: Sun, 24 Sep 2023 22:21:55 +0000

Mauro Aranda <[email-masked]> writes:

> In addition to what Jens Schmidt said, I can add that:
>
> 1. If I have something like:
> my $some_code = "";
> $some_code.= q(
> my $counter = 0;
> );
>
> If I put point at column 0 of the line "my $counter", and hit TAB, I get
> indentation in perl-mode.  I don't in cperl-mode.  I tried to look into
> options for making this work but I couldn't find anything.

I consider the behavior of perl-mode to be a bug.

Whatever is within the parens of  q(...) is a string, and will be
assigned to the variable $some_code.  By "indenting", perl-mode changes
the value of $some_code by adding spaces.  In my opinion, indenting
should change the optical layout, but not the code!

> 2. While I'm typing the above string, I get messages about string/RE not
> found:
> End of ‘q( ... )’ string/RE not found: (scan-error Unbalanced
> parentheses 1092 1874)
> End of ‘q( ... )’ string/RE not found: (scan-error Unbalanced
> parentheses 1092 1918) [2 times]
> End of ‘q( ... )’ string/RE not found: (scan-error Unbalanced
> parentheses 1092 1962) [2 times]
>
> That's annoying.

The message is technically correct, and generally I consider the ability
of cperl-mode to locate syntax errors useful.  But I understand that it
can be annoying while you're typing (I myself don't see these messages
because I use paredit-mode, but I understand that not everyone wants
this electricity).  I guess that a way to optionally suppress these
messages can be found.

The frequency of this error message exploded with the introduction of
jit-lock-mode - before that cperl-mode didn't scan the code for every
character you type.  I think that backing out of jit-lock-mode would not
be wise.

> So far, my settings for getting a perl-mode experience in cperl-mode,
> with emacs -Q: (taken from a custom file):
> '(cperl-highlight-variables-indiscriminately t)
> '(cperl-indent-level 4)
> '(cperl-indent-parens-as-block t)
> '(cperl-invalid-face 'default)
,>
> '(cperl-array-face ((t (:inherit cperl-hash-face))))
> '(cperl-hash-face ((t (:underline t :inherit
> font-lock-variable-name-face))))
> '(cperl-nonoverridable-face ((t (:inherit default))))

Thanks for collecting this!

-- 
Cheers,
haj